package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PphpService;
import com.jasamedika.medifirst2000.vo.SppbVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.HashMap;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/pphp")
public class PphpController extends LocaleController<SppbVO> {

	private static final Logger LOGGER = getLogger(PphpController.class);

	@Autowired
	private PphpService service;

	@RequestMapping(value = "/pre-add-pphp")
	@ResponseBody
	public Map<String, Object> preAddPphp(@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "supplierId", required = false) Integer supplierId) {
		return service.preAddPphp(dateStart, dateEnd, supplierId);
	}

	@RequestMapping(value = "/detail-sppb", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> detailSppb(@RequestParam(value = "noRec") String noRec) {
		return service.detailSppb(noRec);
	}

	@RequestMapping(value = "/save-pphp/", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveSppb(@Valid @RequestBody SppbVO vo, HttpServletRequest request,
			HttpServletResponse response) {
		try {
			Map<String, Object> result = service.savePphp(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when savePphp", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when savePphp", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/list-pphp")
	@ResponseBody
	public Map<String, Object> listPphp(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "10000") Integer limit,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@RequestParam(value = "dateStart", required = false) String dateStart,
			@RequestParam(value = "dateEnd", required = false) String dateEnd,
			@RequestParam(value = "supplierId", required = false) Integer supplierId) {
		return service.daftarPphp(page, limit, sort, dir, dateStart, dateEnd, supplierId);
	}

	@RequestMapping(value = "/konversi")
	@ResponseBody
	public Map<String, Object> konversi(@RequestParam(value = "satuanAwal") Integer satuanAwal,
			@RequestParam(value = "satuanAhir") Integer satuanAhir,
			@RequestParam(value = "qty", required = false, defaultValue = "0.0") Double qty) {
		Double k = service.konversi(satuanAwal, satuanAhir, qty);
		Map<String, Object> resultPageMap = new HashMap<>();
		resultPageMap.put("value", k);
		return resultPageMap;
	}

}
